{
  config,
  lib,
  pkgs,
  ...
}:
with lib;
{
  imports = [ ./embedded.nix ];

  options.development.enableGit = mkOption {
    type = types.bool;
    default = true;
    example = false;
    description = ''
      Enable git and its configuration.
    '';
  };

  config.programs.git = mkIf config.development.enableGit {
    enable = true;
    package = pkgs.gitAndTools.gitFull;
    userName = "Victor Mignot";
    userEmail = "dala@dalaran.fr";
    signing = mkIf config.enableGPGKeyring {
      key = "BEAFED3D";
      signByDefault = true;
    };
    extraConfig = {
      init = {
        defaultBranch = "main";
      };
      core = {
        editor = "${pkgs.helix}/bin/hx";
      };
    };
  };
}
