{
  lib,
  pkgs,
  config,
  nvidiaGPU,
  ...
}:
with lib;
{
  options.enableFishShell = mkOption { type = types.bool; };

  config.programs.fish = mkIf config.enableFishShell {
    enable = true;

    plugins = [
      {
        name = "bobthefish";
        src = pkgs.fetchFromGitHub {
          owner = "oh-my-fish";
          repo = "theme-bobthefish";
          rev = "c2c47dc964a257131b3df2a127c2631b4760f3ec";
          sha256 = "sha256-LB4g+EA3C7OxTuHfcxfgl8IVBe5NufFc+5z9VcS0Bt0=";
          fetchSubmodules = true;
        };
      }
    ];

    shellInit = ''
      set -g theme_color_scheme nord
      if [ -z $DISPLAY ] && [ "$(tty)" = /dev/tty1 ]
        exec sway
      end
    '';
  };
}
